-- Main.lua
-- Originally written by Rod, extended by Habna

-- HugeBag Known bugs:
-- Unload command is not working ( Known API Issues ) ( Working but with the Utility plugin )
-- Reload command is not working ( Known API Issues ) ( Working but with the Utility plugin )
-- When right clicking on a tool the icon is not swaping properly ( Known API Issues )
-- Replace HugeBag when the display size changed. (It's currently replacing himself when any bags action event is fired)

-- HugeBag future functions:
-- Show gold, silver, copper, shards and Perks amout at bottom of bag

-- HugeBag change log:
-- 1.1.12 (2011/06/29): Added the ability to set HugeBag widget to the left or right of the screen.

-- 1.1.11 (2011/06/27): Updated the sort function to version 83 of SortBag.

-- 1.1.10 (2011/06/05): Added a label on the bottom border to quickly sort your bag.
--					  : Bug fix: HugeBag was not replacing himself correctly when 'reset all settings' was launch.
--					  : Added the option to change HugeBag background in both mode.

-- 1.1.9 (2011/05/29) : Added a resize 'UpDown arrow' cursor when mouse hover the 'Top Left Corner' or the 'Bottom Left Corner'

-- 1.1.8c(2011/05/29) : Fix error on line 252, it was a futur fonction that I forgot to disabled before v1.1.8 release.

-- 1.1.8 (2011/05/27) : Added the option to change the top position of the HugeBag widget.

-- 1.1.7c2(2011/05/26): Correction of the HugeBag Utility that was not showing properly.

-- 1.1.7c (2011/05/26): Forgot a function for the sorting module, my bad.

-- 1.1.7 (2011/05/25) : Added the sorting ability. Courtesy of MrJackdaw, author of the 'SortPack' plugin.

-- 1.1.6c(2001/05/25) : Items was not swapping correctly, my bad

-- 1.1.6 (2001/05/25) : Partial bug fix: HugeBag Widget will replace himself (at any bag action event, not when the display size has changed) at the right place if the window size has changed.
--					  : Bug fix: HugeBag Widget will resize to fit your 3 or 5 bags.
--					  : Work around: The 'Unload', 'Load' & 'Reload' commands are now available only if user load the 'HugeBag - Utility' plugin.

-- 1.1.5 (2011/05/24) : Added the option to switch between window and widget mode, default mode is widget.

-- 1.0.5 (2011/05/21) : Changed the content menu into a window.
--					  : Changed the layout of the "Shell Command" window.

-- 1.0.4 (2011/05/20) : Added the option to show free or used slots informations in the title.
--					  : Added the 'About' window.
--					  : Added the 'Shell Command' window.

-- 1.0.3c (2011/05/19): Bug fix: I disabled some context menu option without testing the code before v1.0.3 release 

-- 1.0.3 (2011/05/19) : Bug fix: HugeBag is independant of any plugins manager. User can load/unload HugeBag manually with shell command.
--					  : Added the option to lock/unlock Hugebag size.
--					  : Added the option to lock/unlock Hugebag position.
--					  : Bug fix: HugeBag will not go beyond the screen border in window-mode.
--					  : Added the option for the settings to uptaded himself if a different version is detected, old user settings will remains unchanged.
--					  : Added the option to only reset location and size settings to default.
--					  : Added the option to resize HugeBag from both bottom corner.
--					  : Watermark label was removed, it will be in the 'about' window when it will be available.
--					  : Alot of functions are now in a seperate file. To clean the main file a bit.
--					  : All settings functions are now in a seperate file. To clean the main file a bit. 

-- 1.0.2 (2011/05/16) : Bug fix: Was unable to resize HugeBag when the 'reset' was launch.
--					  : Added a Watermark label of the authors Rod & Habna.
--					  : Added the option to toggle the hide HugeBag event when 'esc' key is press.
--					  : Independant of Turbine plugins.

-- 1.0.1 (2011/05/15) : Added a context menu with right mouse click on the upper left corner.

-- 1.0.0 (2011/05/15) : Initial release.

import "Turbine.Gameplay";
import "HabnaPlugins.HugeBag";

Version = "1.1.12"; --> ** HugeBag current version **

Modesettings = {};
Modesettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagMode" );

-- **v no setting found, so save it v**
if Modesettings == nil then
	Modesettings = {};
	Modesettings.Widget = true;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Load Settings v**
Widget = Modesettings.Widget;
-- **^

if ( Widget ) then
	import "HabnaPlugins.HugeBag.frmMainWidget";
else
	import "HabnaPlugins.HugeBag.frmMain";
end

frmMain = frmMain();

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( Widget ) then
		if ( arguments == "show" ) then
			ShowHugeBag()
		elseif ( arguments == "hide" ) then
			HideHugeBag()
		elseif ( arguments == "version" ) then
			VersionInfo()
		elseif ( arguments == "author" or arguments == "authors" ) then
			AuthorsInfo()
		elseif ( arguments == "about" ) then
			ShowAbout()
		elseif ( arguments == "resetall" ) then
			ResetSettings()
		elseif ( arguments == "help" or arguments == "?") then
			HelpInfo()
		elseif ( arguments == "slotsinfo" ) then
			SlotsInfo()
		--elseif ( arguments == "unload" ) then
			--UnloadHugeBag()
		--elseif ( arguments == "reload" ) then
			--ReloadHugeBag()
		elseif ( arguments == "sort" ) then
			SortHugeBag()
		elseif ( arguments == "toggleshow" ) then
			ToggleShow()
		elseif ( arguments == "togglewesc" ) then
			ToggleWEsc()
		elseif ( arguments == "togglewidget" ) then
			ToggleWidgetMode()
		elseif ( arguments == "curopt" ) then
			frmMain.menu:ShowMenu()
		else
			write( "HugeBag: Command not supported" );
		end
	else
		if ( arguments == "show" ) then
			ShowHugeBag()
		elseif ( arguments == "hide" ) then
			HideHugeBag()
		elseif ( arguments == "version" ) then
			VersionInfo()
		elseif ( arguments == "author" or arguments == "authors" ) then
			AuthorsInfo()
		elseif ( arguments == "about" ) then
			ShowAbout()
		elseif ( arguments == "resetall" ) then
			ResetSettings()
		elseif ( arguments == "resetls" ) then
			ResetLSSettings()
		elseif ( arguments == "help" or arguments == "?") then
			HelpInfo()
		elseif ( arguments == "slotsinfo" ) then
			SlotsInfo()
		--elseif ( arguments == "unload" ) then
			--UnloadHugeBag()
		--elseif ( arguments == "reload" ) then
			--ReloadHugeBag()
		elseif ( arguments == "sort" ) then
			SortHugeBag()
		elseif ( arguments == "locksize" ) then
			LockHugeBagSize()
		elseif ( arguments == "lockpos" or arguments == "lockposition") then
			LockHugeBagPosition()
		elseif ( arguments == "toggleshow" ) then
			ToggleShow()
		elseif ( arguments == "toggleslots" ) then
			ToggleSlotsInfo()
		elseif ( arguments == "toggleused" ) then
			ToggleFreeUsed()
		elseif ( arguments == "togglewesc" ) then
			ToggleWEsc()
		elseif ( arguments == "togglewidget" ) then
			ToggleWidgetMode()
		elseif ( arguments == "curopt" ) then
			ShowCurrentSettings()
		else
			write( "HugeBag: Command not supported" );
		end
	end
end
Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );
--[[
if ( StartVisible ) then
	write( "HugeBag v" .. Version .. " by Habna: I'm loaded" );
else
	Turbine.Shell.WriteLine( "HugeBag v" .. Version .. " by Habna: I'm loaded BUT NOT visible" );
end

if ( ShowSlotsInfo ) then SlotsInfo() end
]]
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
end