-- frmOptions.lua
-- Written by Habna


function frmOptions()
	self = Turbine.UI.Lotro.Window();
	--self = Turbine.UI.Lotro.GoldWindow()
	
	local initHeight = 150;
	local initWidth = 400;
	local initLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2;
	local initTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2;

	bcCtr = Turbine.UI.Control();

	self.Opacity = 1;
	self:SetSize( initWidth, initHeight );
	self:SetPosition( initLeft, initTop );
	self:SetVisible( true );
	self:SetText( "Set HugeBag Background" );

	ColorPreviewBC=Turbine.UI.Label();
	ColorPreviewBC:SetParent( self );
	ColorPreviewBC:SetSize( 57, 57 );
	ColorPreviewBC:SetPosition( 314, 49 );
	ColorPreviewBC:SetBackColor( white );

	ColorPreview=Turbine.UI.Label();
	ColorPreview:SetParent( self );
	ColorPreview:SetSize( 55, 55 );
	ColorPreview:SetPosition( 315, 50 );
	ColorPreview:SetBackColor( Turbine.UI.Color( bcAlpha * 100, bcRed * 100, bcGreen * 100, bcBlue * 100 ) );

	-- **v To create a new button v**
	local buttonClose = Turbine.UI.Lotro.Button();
	buttonClose:SetParent( self );
	buttonClose:SetPosition( 275, self:GetHeight() - 30 );
	buttonClose:SetSize( 75, 150 );
	buttonClose:SetText( "Close" );
	buttonClose:SetVisible( true );
	-- **^
	-- **v To create a new button v**
	local buttonDefault = Turbine.UI.Lotro.Button();
	buttonDefault:SetParent( self );
	buttonDefault:SetPosition( 175, self:GetHeight() - 30 );
	buttonDefault:SetSize( 75, 150 );
	buttonDefault:SetText( "Default" );
	buttonDefault:SetVisible( true );
	-- **^

	-- Create alpha label and slider.
	local alphalabel = Turbine.UI.Label();
	alphalabel:SetParent( self );
	alphalabel:SetText( "Alpha" );
	alphalabel:SetPosition( 50, 50 );
	alphalabel:SetSize( 250, 10 );
	alphalabel:SetBackColor( Turbine.UI.Color( 0.5, 0.3, 0.3, 0.3 ) );
	alphalabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	alphaScrollBar = Turbine.UI.Lotro.ScrollBar();
	alphaScrollBar:SetParent( alphalabel );
	alphaScrollBar:SetPosition( 0, 1 );
	alphaScrollBar:SetSize( 250, 10 );
	alphaScrollBar:SetMinimum( 0 );
	alphaScrollBar:SetMaximum( 100 );
	alphaScrollBar:SetValue( settings.BackColor.A * 100);
	
	-- Create red label and slider.
	local redlabel = Turbine.UI.Label();
	redlabel:SetParent( self );
	redlabel:SetText( "Red" );
	redlabel:SetPosition( 50, 65 );
	redlabel:SetSize( 250, 10 );
	redlabel:SetBackColor( Turbine.UI.Color( 1, 0.6, 0, 0 ) );
	redlabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	redScrollBar = Turbine.UI.Lotro.ScrollBar();	
	redScrollBar:SetParent( redlabel );
	redScrollBar:SetPosition( 0, 1);
	redScrollBar:SetSize( 250, 10 );
	redScrollBar:SetMinimum( 0 );
	redScrollBar:SetMaximum( 100 );
	redScrollBar:SetValue( settings.BackColor.R * 100);
	
	-- Create green label and slider.
	local greenlabel = Turbine.UI.Label();
	greenlabel:SetParent( self );
	greenlabel:SetText( "Green");
	greenlabel:SetPosition( 50, 80 );
	greenlabel:SetSize( 250, 10 );
	greenlabel:SetBackColor( Turbine.UI.Color( 1, 0, 0.6, 0 ) );
	greenlabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	greenScrollBar = Turbine.UI.Lotro.ScrollBar();
	greenScrollBar:SetParent( greenlabel );
	greenScrollBar:SetPosition( 0, 1);
	greenScrollBar:SetSize( 250, 10 );
	greenScrollBar:SetMinimum( 0 );
	greenScrollBar:SetMaximum( 100 );
	greenScrollBar:SetValue( settings.BackColor.G * 100);
	
	-- Create blue label and slider.
	local bluelabel = Turbine.UI.Label();
	bluelabel:SetParent( self );
	bluelabel:SetText( "Blue" );
	bluelabel:SetPosition( 50, 95 );
	bluelabel:SetSize( 250, 10 );
	bluelabel:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.6 ) );
	bluelabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	blueScrollBar = Turbine.UI.Lotro.ScrollBar();
	blueScrollBar:SetParent( bluelabel );
	blueScrollBar:SetPosition( 0, 1);
	blueScrollBar:SetSize( 250, 10 );
	blueScrollBar:SetMinimum( 0 );
	blueScrollBar:SetMaximum( 100 );
	blueScrollBar:SetValue( settings.BackColor.B * 100);

	-- **v Button close click event v**
	buttonClose.Click = function(sender, args)
		bcCtr:SetWantsUpdates( false );
		self:Close();
	end
	-- **^
	-- **v Button default click event v**
	buttonDefault.Click = function(sender, args)
		alphaScrollBar:SetValue ( 1 * 100 );
		redScrollBar:SetValue ( 0 * 100 );
		greenScrollBar:SetValue ( 0 * 100 );
		blueScrollBar:SetValue ( 0 * 100 );
		SaveSettings();
	end
	-- **^

	bcCtr.Update = function( sender, args )
		bcAlpha = alphaScrollBar:GetValue() / 100;
		bcRed = redScrollBar:GetValue() / 100;
		bcGreen = greenScrollBar:GetValue() / 100;
		bcBlue = blueScrollBar:GetValue() / 100;
		ColorPreview:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
		frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
		SaveSettings();
	end

	alphaScrollBar.MouseUp = bcCtr:SetWantsUpdates( false );
	redScrollBar.MouseUp = bcCtr:SetWantsUpdates( false );
	greenScrollBar.MouseUp = bcCtr:SetWantsUpdates( false );
	blueScrollBar.MouseUp = bcCtr:SetWantsUpdates( false );

	alphaScrollBar.ValueChanged = bcCtr:SetWantsUpdates( true );
	redScrollBar.ValueChanged = bcCtr:SetWantsUpdates( true );
	greenScrollBar.ValueChanged = bcCtr:SetWantsUpdates( true );
	blueScrollBar.ValueChanged = bcCtr:SetWantsUpdates( true );
end
-- **^