-- frmSettings.lua
-- Written by Habna

-- **v Load settings v**
function LoadSettings()
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		WinLocX = Turbine.UI.Display.GetWidth() - edgePadding - WinWidth
		WinLocY = Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55
		SaveSettings()
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.Location.X;
	WinLocY = settings.Location.Y;
	WinWidth = settings.Size.W;
	WinHeight = settings.Size.H;
	HideWEsc = settings.Options.HideWEsc;
	StartVisible = settings.Options.StartVisible;
	ShowSlotsInfo = settings.Options.ShowSlotsInfo;
	ToggleUsed = settings.Options.ShowUsedInfo;
	LockPosition = settings.Options.LockPosition;
	LockSize = settings.Options.LockSize;
	bcAlpha = settings.BackColor.A;
	bcRed = settings.BackColor.R;
	bcGreen = settings.BackColor.G;
	bcBlue = settings.BackColor.B;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		Updatedsettings = {};
		Updatedsettings.Options = {};

		if settings.Options.StartVisible == nil then
			Updatedsettings.Size.StartVisible = true;
		else
			Updatedsettings.Options.StartVisible = StartVisible;
		end
		if settings.Options.ShowSlotsInfo == nil then
			Updatedsettings.Options.ShowSlotsInfo = true;
		else
			Updatedsettings.Options.ShowSlotsInfo = ShowSlotsInfo;
		end

		Updatedsettings.Location = {};
		Updatedsettings.Location.X = WinLocX;
		Updatedsettings.Location.Y = WinLocY;

		Updatedsettings.Size = {};
		Updatedsettings.Size.W = WinWidth;
		Updatedsettings.Size.H = WinHeight;

		if settings.Options.HideWEsc == nil then
			Updatedsettings.Options.HideWEsc = false;
		else
			Updatedsettings.Options.HideWEsc = HideWEsc;
		end
		if settings.Options.LockPosition == nil then
			Updatedsettings.Options.LockPosition = false;
		else
			Updatedsettings.Options.LockPosition = LockPosition;
		end
		if settings.Options.LockSize == nil then
			Updatedsettings.Options.LockSize = false;
		else
			Updatedsettings.Options.LockSize = LockSize;
		end
		if settings.Options.ShowUsedInfo == nil then
			Updatedsettings.Options.ShowUsedInfo = false;
		else
			Updatedsettings.Options.ShowUsedInfo = ToggleUsed;
		end

		Updatedsettings.BackColor = {};
		Updatedsettings.BackColor.A = bcAlpha;
		Updatedsettings.BackColor.R = bcRed;
		Updatedsettings.BackColor.G = bcGreen;
		Updatedsettings.BackColor.B = bcBlue;

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;

	settings.Location = {};
	settings.Location.X = WinLocX;
	settings.Location.Y = WinLocY;

	settings.Size = {};
	settings.Size.W = WinWidth;
	settings.Size.H = WinHeight;

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	settings.Options.ShowSlotsInfo = ShowSlotsInfo;
	settings.Options.ShowUsedInfo = ToggleUsed;
	settings.Options.HideWEsc = HideWEsc;
	settings.Options.LockPosition = LockPosition;
	settings.Options.LockSize = LockSize;

	settings.BackColor = {};
	settings.BackColor.A = bcAlpha;
	settings.BackColor.R = bcRed;
	settings.BackColor.G = bcGreen;
	settings.BackColor.B = bcBlue;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = true;
	ShowSlotsInfo = true;
	ToggleUsed = false;
	HideWEsc = false;
	LockPosition = false;
	LockSize = false;
	Widget = Widget;
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	bcAlpha, bcRed, bcGreen, bcBlue = 1, 0, 0, 0;
	frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	frmMain:PrintTitle()
	SaveSettings()
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^