-- frmSettingsWidget.lua
-- Written by Habna


-- **v Load settings v**
function LoadSettings()
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettings" );
	
	-- **v no settings found, create it v**
	if settings == nil then
		SaveSettings();
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.Location.X;
	WinLocY = settings.Location.Y;
	WidgetLoc = settings.Location.Loc;
	HideWEsc = settings.Options.HideWEsc;
	StartVisible = settings.Options.StartVisible;
	bcAlpha = settings.BackColor.A;
	bcRed = settings.BackColor.R;
	bcGreen = settings.BackColor.G;
	bcBlue = settings.BackColor.B;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		Updatedsettings = {};

		Updatedsettings.Location = {};
		Updatedsettings.Location.X = WinLocX;
		Updatedsettings.Location.Y = WinLocY;

		if settings.Location.Loc == nil then
			Updatedsettings.Location.Loc = "right";
		else
			Updatedsettings.Location.Loc = WidgetLoc;
		end

		Updatedsettings.Options = {};
		if settings.Options.HideWEsc == nil then
			Updatedsettings.Options.HideWEsc = false;
		else
			Updatedsettings.Options.HideWEsc = HideWEsc;
		end

		if settings.Options.StartVisible == nil then
			Updatedsettings.Options.StartVisible = false;
		else
			Updatedsettings.Options.StartVisible = StartVisible;
		end

		Updatedsettings.BackColor = {};
		Updatedsettings.BackColor.A = bcAlpha;
		Updatedsettings.BackColor.R = bcRed;
		Updatedsettings.BackColor.G = bcGreen;
		Updatedsettings.BackColor.B = bcBlue;

		if settings.WidgetLoc == nil then
			Updatedsettings.WidgetLoc = right;
		else
			Updatedsettings.WidgetLoc = WidgetLoc;
		end

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	settings.Options.HideWEsc = HideWEsc;

	settings.Location = {};
	settings.Location.X = WinLocX;
	settings.Location.Y = WinLocY;
	settings.Location.Loc = WidgetLoc;

	settings.BackColor = {};
	settings.BackColor.A = bcAlpha;
	settings.BackColor.R = bcRed;
	settings.BackColor.G = bcGreen;
	settings.BackColor.B = bcBlue;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	frmMain:SetPosition( screenWidth - 28, 440 );
	WinLocX, WinLocY = frmMain:GetPosition();
	WidgetLoc = "right";
	StartVisible = false;
	HideWEsc = false;
	Widget = Widget;
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3;
	itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	if ( windowOpen ) and ( not StartVisible ) then
		frmMain:SetVisible( true );
		slideCtr:SetWantsUpdates(true);
	end
	SaveSettings()
	write( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--